<template>
  <div class="login">
    <div class="loginBox">
      <div class="login-area">
        <p
          class="login-top"
          style="font-size:22px"
        >
          {{ $t('login.loginWithUser') }}
        </p>
        <!--<el-input
          id="uname"
          v-model="userData.username"
          type="text"
          :placeholder="$t('login.userName')"
        />
        <el-input
          id="upass"
          v-model="userData.password"
          type="password"
          :placeholder="$t('login.pwdPla')"
        />-->
        <el-form
          :model="userData"
          status-icon
          :rules="rules"
          ref="userData"
          class="demo-ruleForm"
        >
          <el-form-item prop="username">
            <el-input
              id="name"
              v-model="userData.username"
              auto-complete="new-accounts"
              type="text"
              :placeholder="$t('user.username')"
            />
          </el-form-item>
          <el-form-item prop="password">
            <el-input
              id="firstpwd"
              v-model="userData.password"
              auto-complete="new-password"
              type="password"
              :placeholder="$t('login.password')"
            />
          </el-form-item>
        </el-form>
      </div>
      <div class="login-btn">
        <drag-verify
          :width="width"
          :height="height"
          :text="text"
          :success-text="successText"
          :background="background"
          :progress-bar-bg="progressBarBg"
          :completed-bg="completedBg"
          :handler-bg="handlerBg"
          :handler-icon="handlerIcon"
          :text-size="textSize"
          :success-icon="successIcon"
          :circle="false"
          ref="Verify"
          @passcallback="verifySuccess"
        />
      </div>
      <div class="login-btn">
        <el-button
          id="loginBtn"
          type="primary"
          class="myButton"
          size="medium"
          :loading="loginBtnLoading"
          @click="submitForm()"
        >
          {{ $t('login.login') }}
        </el-button>
      </div>
      <div class="login-tips rt">
        <el-button
          type="text"
          @click="jumpTo('/registration')"
        >
          {{ $t('login.freeSign') }}
        </el-button>
        <el-divider
          direction="vertical"
          v-if="this.enableSms"
        />
        <el-button
          type="text"
          @click="jumpTo('/guest/home')"
        >
          {{ $t('nav.beaguest') }}
        </el-button>
      </div>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'
import dragVerify from 'vue-drag-verify'
export default {
  name: '',
  components: {
    dragVerify
  },
  data () {
    var validateName = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Username cannot be empty'))
      } else {
        if (this.userData.checkPass !== '') {
          this.$refs.userData.validateField('checkPass')
        }
        callback()
      }
    }
    var validatePass = (rule, value, callback) => {
      if (value === '') {
        callback(new Error('Password cannot be empty'))
      } else {
        if (this.userData.checkPass !== '') {
          this.$refs.userData.validateField('checkPass')
        }
        callback()
      }
    }
    return {
      userData: {
        username: '',
        password: ''
      },
      loginBtnLoading: false,
      verifyStatus: false,
      returnUrl: '',
      enableSms: '',
      handlerIcon: 'el-icon-d-arrow-right',
      successIcon: 'el-icon-check',
      background: '#FFCCCC',
      progressBarBg: '#4b0',
      completedBg: '#66cc66',
      handlerBg: '#fff',
      text: this.$t('login.verify'),
      successText: this.$t('login.finishVerify'),
      width: 360,
      height: 40,
      textSize: '16px',
      interval: null,
      rules: {
        username: [
          { validator: validateName, trigger: 'blur' }
        ],
        password: [
          { validator: validatePass, trigger: 'blur' }
        ]
      }
    }
  },
  watch: {
    '$i18n.locale': function () {
      this.text = this.$t('login.verify')
      this.successText = this.$t('login.finishVerify')
    }
  },
  created () {
    this.keyupSubmit()
  },
  mounted () {
    if (window.location.href.indexOf('return_to=') > -1) {
      this.returnUrl = this.getQueryString('return_to')
      this.enableSms = this.getQueryString('enable_sms')
      if (this.enableSms.indexOf('true') > -1) {
        this.enableSms = true
      } else {
        this.enableSms = false
      }
      let obj = {
        return_url: this.returnUrl,
        enable_sms: this.enableSms,
        login_url: window.location.href.split('#')[1]
      }
      sessionStorage.setItem('obj', JSON.stringify(obj))
    }
    this.interval = setInterval(() => {
      this.setDivWidth()
    }, 100)
    let userInfo = JSON.parse(sessionStorage.getItem('userinfo'))
    if (userInfo) {
      this.userData.username = userInfo.username
      this.userData.password = userInfo.password
    }
  },
  beforeDestroy () {
    this.clearInterval()
  },
  methods: {
    setDivWidth () {
      let screenWidth = document.body.clientWidth
      if (screenWidth >= 640) {
        this.width = 360
      } else {
        this.width = 260
      }
    },
    clearInterval () {
      clearTimeout(this.interval)
      this.interval = null
    },
    verifySuccess () {
      if (this.$refs.Verify.isPassing) {
        this.verifyStatus = true
      } else {
        this.verifyStatus = false
      }
    },
    getQueryString (name) {
      let reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i')
      let r = window.location.href.split('?')[1].substr(0).match(reg)
      if (r != null) {
        return decodeURIComponent(r[2])
      }
      return null
    },
    submitForm () {
      this.$refs['userData'].validate((valid) => {
        if (valid) {
          if (this.verifyStatus) {
            this.loginBtnLoading = true
            let url = BASE_URL + '/login'
            axios({
              method: 'POST',
              url: url,
              data: this.userData,
              headers: {
                'Content-Type': 'application/json'
              }
            }).then(res => {
              this.$parent.successMessage(this.$t('confirm.userLoginSuccess'))
              let userData = res.data
              sessionStorage.setItem('user', JSON.stringify(userData))
              sessionStorage.setItem('role', userData.role)
              sessionStorage.setItem('userId', userData.userId)
              this.loginBtnLoading = false
              let uRole = userData.role.toLowerCase().trim()
              switch (uRole) {
                case 'administrator':
                  this.jumpTo('/administrator/home')
                  break
                case 'appdeveloper':
                  this.jumpTo('/app/home')
                  break
                case 'communitydeveloper':
                  this.jumpTo('/community/home')
                  break
                default:
                  this.jumpTo('/guest/home')
              }
            }, error => {
              this.loginBtnLoading = false
              if (error) {
                document.location.reload()
                this.$parent.errorMessage(this.$t(error.response.data))
              }
            })
          } else {
            this.$message.error(this.$t('login.wrongCaptcha'))
            this.loginBtnLoading = false
            document.location.reload()
          }
        }
      })
    },
    keyupSubmit () {
      document.onkeydown = e => {
        let _key = window.event.keyCode
        if (_key === 13) {
          this.submitForm()
        }
      }
    },
    jumpTo (path) {
      if (this.$route.path !== path) {
        this.$router.push(path)
      }
    }
  }
}
</script>
<style lang="less">
.login {
  background-image: url("../assets/images/login.png");
  width: 100vw;
  height: 100vh;
  background-size: 100% 100%;
  background-repeat: no-repeat;
  position: relative;
  .loginBox {
    float: right;
    width: 410px;
    height: auto;
    text-align: center;
    margin: 10% 12% 0 0;
    padding: 25px 15px;
    background: #fff;
    box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.16),
      0 2px 10px 0 rgba(0, 0, 0, 0.12) !important;
    .login-top {
      text-align: center;
      display: inline-block;
      width: 100%;
      line-height: 18px;
      font-size: 18px;
      font-family: PingFangSC-Medium,sans-serif;
      color: #252b3a;
      margin-bottom: 25px;
    }
    .login-area {
      padding: 0 25px;
      .el-input {
        margin: 5px 0;
      }
    }
    .login-certify {
      padding: 0 25px;
      margin: 25px 0;
      span {
        display: inline-block;
        width: 100%;
        height: 100%;
        line-height: 38px;
        border: 1px solid #ddd;
        border-radius: 5px;
        font-size: 18px;
        font-weight: bold;
        cursor: pointer;
      }
    }
  }
  @media screen and (max-width: 640px) {
    .loginBox{
      width: 310px;
      margin: 5% 10px 0 0;
    }
  }
  .login-btn {
    padding: 0 25px;
    button {
      width: 100%;
      font-size: 18px;
    }
    .verify-box em{
      top: 0;
    }
    .drag_verify{
      margin-bottom: 15px;
    }
    .drag_verify .dv_handler i{
      font-size: 16px;
    }
  }
  .login-tips {
    margin-top: 15px;
    padding: 0 25px;
    span {
      font-size: 15px;
      color: #252b3a;
      line-height: 18px;
      cursor: pointer;
      text-decoration: underline
    }
  }
}
.el-dialog__body {
  /*height: 123px;*/
}
.myButton {
    box-shadow: 1px 2px 10px 4px #1564ad;
    background:linear-gradient(to bottom, #79bbff 5%, #378de5 100%);
    background-color:#79bbff;
    border-radius:2px;
    border:1px solid #337bc4;
    display:inline-block;
    cursor:pointer;
    color:#ffffff;
    font-family:Arial;
    font-size:17px;
    font-weight:bold;
    padding:11px 76px;
    text-decoration:none;
    text-shadow:-2px -1px 19px #528ecc;
    margin-top:20px;
}
.myButton:hover {
    background:linear-gradient(to bottom, #378de5 5%, #79bbff 100%);
    background-color:#378de5;
}
.myButton:active {
    position:relative;
    top:1px;
}
</style>
